Changes between Version 1 and Version 7 of Ticket #113


Ignore:
Timestamp:
01/11/14 23:15:34 (6 years ago)
Author:
ossi
Comment:

Legend:

Unmodified
Added
Removed
Modified
  • Ticket #113

    • Property Status changed from new to closed
    • Property Reporter changed from slavazanko to ossi
    • Property Component changed from mc-core to mcedit
    • Property Owner set to slavazanko
    • Property Branch state changed from to no branch
    • Property Keywords review added
    • Property Resolution changed from to fixed
  • Ticket #113 – Description

    v1 v7  
    77||Release:||current (CVS or snapshot)||Operating System:||All|| 
    88 
    9 Discussion: 
    10 {{{ 
    11 Sun 06 Jul 2008 04:12:04 PM UTC, comment #24: 
    12  
    13 I noticed I cannot just use the Unicode characters (like p->ch =  
    14 0xB7), as that does not take into account terminals that are not in  
    15 UTF-8. But the fix is simple enough (p->ch = SLsmg_Is_Unicode ? 0xB7 : "."). 
    16  
    17 BTW, I also implemented the MS Word-style "tabs", i.e. printing a  
    18 right-arrow in the middle of a tab. I sort of prefer it over the  
    19 "<---->" tabs. It is a patch that currently replaces the existing  
    20 tab mechanism, but IMHO this should all be made configurable once  
    21 the maintainers decide to wake up and give me some sort of ok... 
    22  
    23 (file #16007) 
    24         Jan Engelhardt <hirogen2> 
    25 Sun 06 Jul 2008 01:24:09 PM UTC, comment #23: 
    26  
    27 Patch #4 -- cedit-symbol-prefs.diff 
    28  
    29 This patch changes the space fill character to some Unicode dot (·)  
    30 [this one is also available on the text console], and makes the  
    31 <------> tab filler into the Unicode ◀──────▶ too. 
    32  
    33 (file #16006) 
    34         Jan Engelhardt <hirogen2> 
    35 Sun 06 Jul 2008 01:21:22 PM UTC, comment #22: 
    36  
    37 Patch #3 -- cedit-fix-whitespace.diff 
    38  
    39 We definitely need to set MOD_WHITESPACE or the space between tab  
    40 stops is drawn with some random color. 
    41  
    42 (file #16005) 
    43         Jan Engelhardt <hirogen2> 
    44 Sun 06 Jul 2008 01:19:54 PM UTC, comment #21: 
    45  
    46 Patch #2 -- cedit-eol-mark.diff 
    47  
    48 This patch implements comment #8's suggestion to use ¶ as an EOL  
    49 marker. It can be toggled using the Options>Highlight options  
    50 dialog, or, of course, by editing ~/.mc/config directly. 
    51  
    52 (file #16004) 
    53         Jan Engelhardt <hirogen2> 
    54 Sun 06 Jul 2008 01:17:43 PM UTC, comment #20: 
    55  
    56 Ok since nobody replied here are some patches of my own. 
    57 They require that mc(edit) has COMPLETE support for UTF-8!, which  
    58 is not the case in the mc source distribution. The openSUSE  
    59 .src.rpm has the required utf8 bits. Will try to make them submit  
    60 theirs. 
    61  
    62 Patch #1 -- cedit-configurable-highlight.diff 
    63  
    64 This is for comment #19; it allows to switch highlighting. Firstly,  
    65 it adds a dialog (Options > Highlight options) where you can  
    66 precisely select what to highlight 
    67  
    68 [ ] Global syntax highlighting 
    69  
    70 [ ] Tab highlighting (those <------> markers, which, btw, can get  
    71 very ugly if you have lots of code) 
    72  
    73 [ ] Whitespace highlighting (dots at the end-of-line, and, if tab  
    74 highlighting is disabled, anywhere on the line) 
    75  
    76 One can already toggle Syntax highlighting with Ctrl-S in mc 4.6.2,  
    77 for the latter two, I added Ctrl-V as a hotkey which cycles through  
    78 the possibilities. My personal preference is to have Tab highlight  
    79 OFF and Whitespace highlight ON. 
    80  
    81 (file #16003) 
    82         Jan Engelhardt <hirogen2> 
    83 Fri 29 Feb 2008 07:16:33 PM UTC, comment #19: 
    84  
    85 Oh, god... I just updated my Debian box, and I now run MC  
    86 4.6.2-pre1 (as outputted by mcedit --version). It appears that this  
    87 patch is included in this version of mcedit. I really dislike it.  
    88 Besides suffering from the 'cursor disappearing' thingy, I just  
    89 think its ugly. But that's my humble opinion :) 
    90 How can I disable it? The patches attached to this report don't  
    91 seem to make a new configurable parameter available in the  
    92 configuration dialogs. 
    93         Jurrie Overgoor <leadpumper> 
    94 Tue 04 Sep 2007 05:29:40 AM UTC, comment #18: 
    95  
    96 Pavel, I applied your patch to vte-0.16.8. It works. 
    97         Andrew Borodin <a_borodin> 
    98 Mon 03 Sep 2007 01:15:42 PM UTC, comment #17: 
    99  
    100 Ok. I tracked the "bug" to vte_terminal_determine_colors() in the  
    101 vte package. To request brighter colors one forces the terminal  
    102 into "bold mode". It seems that in this mode vte allows only the  
    103 foreground color to be bright. In vte's terms a bright color is the  
    104 same color as the normal one but with a special flag set. So what  
    105 happens is that when the time comes for the cursor to blink vte  
    106 switches the current forground color with the current background  
    107 color and vice versa... As I said above 
    108 both colors are indentified in the same way but one has a special  
    109 flag, however vte uses this flag to brighten the foreground color  
    110 so at the end we end up as if nothing happened. It's hard to say  
    111 whether this is the desired behaviour .. I'll attach a simple patch  
    112 which changes vte to do what seems more logically correct... and  
    113 I'll open a report in gnome's bugzilla. 
    114  
    115 (file #13873) 
    116         Pavel Tsekov <ptsekov> 
    117 Project Administrator 
    118 Fri 31 Aug 2007 04:19:43 PM UTC, comment #16: 
    119  
    120 IMO, this must be a bug in gnome-terminal. It doesn't behave  
    121 properly if one uses both the bright and normal colors as the  
    122 background and foreground of the same cell. I changed the 
    123 the definition of "editwhitespace" to "brightred,red" and the  
    124 cursor is not displayed in this case as well. I also changed the  
    125 color for brightblue in my gnome-terminal profile to a different  
    126 color but no matter the cursor wasnt displayed. I'll see if they  
    127 have a bugreport in their bugzilla. 
    128         Pavel Tsekov <ptsekov> 
    129 Project Administrator 
    130 Fri 31 Aug 2007 09:28:17 AM UTC, comment #15: 
    131  
    132 This may be a bug in gnome-terminal as well... I am also using  
    133 gnome-terminal and no matter the color scheme the cursor is  
    134 invisible. I'll investigate further... 
    135         Pavel Tsekov <ptsekov> 
    136 Project Administrator 
    137 Fri 31 Aug 2007 06:07:28 AM UTC, comment #14: 
    138  
    139 Oswald, you are right. This effect is depending on terminal  
    140 emulation program and color scheme. 
    141  
    142 In linux console, cursor is visible every time. The color of cursor  
    143 is changed to light blue in tab and trailing space positions, but  
    144 cursor is visible. 
    145  
    146 The same is in xterm under X. xterm doesn't have any non-default  
    147 cursor settings. 
    148  
    149 In gnome-terminal and multi-gnome-terminal, which I use, cursor  
    150 changes its color and becomes invisible. ("Green on black" color  
    151 scheme and "Linux console" palette are used in both those programs.) 
    152  
    153 Is it possible to make the same cursor color in positions of  
    154 visualized tab an training space as in positions of other symbols? 
    155         Andrew Borodin <a_borodin> 
    156 Thu 30 Aug 2007 12:58:35 PM UTC, comment #13: 
    157  
    158 that's weird ... i see no such effect (little surprisingly). though  
    159 with some terminals/color combinations it becomes light blue, too,  
    160 and thus hardly visible, but i don't think we can do much about  
    161 that. 
    162         Oswald Buddenhagen <ossi> 
    163 Thu 30 Aug 2007 12:39:39 PM UTC, comment #12: 
    164  
    165 Yep. As I said - i'll be fixing the patch... I prefer to have it in  
    166 CVS even if it has minor glitches. In the meantime if you find any  
    167 other problems with it - please, feel free to report them. 
    168         Pavel Tsekov <ptsekov> 
    169 Project Administrator 
    170 Thu 30 Aug 2007 12:29:20 PM UTC, comment #11: 
    171  
    172 Cursor in TAB and trailing space position is disappeared. This is  
    173 very uncomfortable. 
    174         Andrew Borodin <a_borodin> 
    175 Mon 27 Aug 2007 12:08:04 PM UTC, comment #10: 
    176  
    177 The patch is in CVS now. I've commited mcedit-visible-ws-v2.diff  
    178 with no changes whatsoever ... I'll be making changes to it as  
    179 discussed in this bugreport in the next few weeks. 
    180         Pavel Tsekov <ptsekov> 
    181 Project Administrator 
    182 Thu 09 Aug 2007 08:53:35 PM UTC, comment #9: 
    183  
    184 i considered making all whitespace visible, but somehow found it  
    185 pointless and even counterproductive for my use cases. 
    186 for linefeeds, i really see no use case ... 
    187 regarding the use of special characters, this is not doable without  
    188 utter hackery. mc is restricted to the abstract char set provided  
    189 by ncurses/slang, which unfortunately does not provide these chars. 
    190         Oswald Buddenhagen <ossi> 
    191 Thu 09 Aug 2007 08:28:12 PM UTC, comment #8: 
    192  
    193 This mcedit-visible-ws-v2.diff works great with mc-4.6.1 
    194 What a pity it is not inside mc by default. The light blue color is  
    195 great - it shows invisible characters but not disturbs  
    196 reading/editing. 
    197  
    198 There is one little thing I would like to see: 
    199 make tabs, all spaces and carriage returns visible like in OpenOffice/M$ Word. 
    200  
    201 This means that: 
    202 -all spaces are visible as dots ···· (unicode 00B7) (not only  
    203 trailing but all - this is comfortable when hunting for  
    204 double/multi spaces between words). 
    205 -tabs are visible as arrows → (unicode 2192) (somethhing like -> mc  
    206 uses semigraphics so can draw arrows too) 
    207 -carriage returns are visible as reversed P character ¶ (unicode  
    208 00B6) 
    209 (I know this is poor description but just run OO Writer or Word to  
    210 see how these formating characters are marked). 
    211  
    212 I really would like to see this patch in mc as default. It is very  
    213 helpful and allows to keep .conf files clean. 
    214         Zbigniew Luszpinski <mr_zbiggy> 
    215 Sun 05 Feb 2006 04:51:56 PM UTC, comment #7: 
    216  
    217 it just occurred to me, that i don't want two separate shortcuts  
    218 for toggling these options. two separate persistent options in the  
    219 config dialog are ok, but there should be only one "quick toggle"  
    220 shortcut (ctrl-w) that disables both at once, and is not saved  
    221 anywhere. 
    222 i suppose the envisioned ctrl-s shortcut for toggling syntax  
    223 highlighting should be non-persistent as well. 
    224         Oswald Buddenhagen <ossi> 
    225 Mon 30 Jan 2006 05:16:22 PM UTC, comment #6: 
    226  
    227 Single patch is OK. 
    228         Pavel Tsekov <ptsekov> 
    229 Project Administrator 
    230 Mon 30 Jan 2006 04:33:20 PM UTC, comment #5: 
    231  
    232 ok, here's a patch which allows enabling visible trailing  
    233 whitespace and visible tabs independently. i'm not eager to split  
    234 it into two patches; they are too much related. 
    235 i just threw in the options as variables right above the relevant  
    236 function - i'd prefer you wrapping this into proper configurability  
    237 (options in the edit config dialog and keyboard accels) yourself,  
    238 as i'd have to research how to do it first. :} 
    239         Oswald Buddenhagen <ossi> 
    240 Mon 30 Jan 2006 04:19:36 PM UTC, comment #4: 
    241  
    242 ok, i changed my mind - i have a strong opinion now. :) 
    243 i think it's right that trailing tabs should not prevent preceeding  
    244 spaces from being marked as trailing: if trailing whitespace  
    245 removal is implemented, all these chars will be equally killed away. 
    246         Oswald Buddenhagen <ossi> 
    247 Mon 30 Jan 2006 03:53:54 PM UTC, comment #3: 
    248  
    249 I did try it and have been playing with it for a while. This patch 
    250 adds (1) visible trailing spaces and (2) visible tabs. In fact I  
    251 prefer to think of it as two separate patches. As you suggested on  
    252 the list it should be enhanced so that the user can switch this  
    253 functionality on and off via a fast key. I would add that the user  
    254 should be allowed to enable (1) without enabling (2) and vice versa. 
    255         Pavel Tsekov <ptsekov> 
    256 Project Administrator 
    257 Mon 30 Jan 2006 03:35:14 PM UTC, comment #2: 
    258  
    259 well, tabs should stay tabs. masking them away in this special case  
    260 would just lead to surprises. 
    261 not sure about your example. it's true that it looks a bit weird.  
    262 otoh, such whitespace is plainly broken, so it should look broken.  
    263 :) also, if you change it, suddenly chars in the middle of a line  
    264 will vanish/appear if you (append past/remove up to) the trailing  
    265 tabs. it depends on whether one wants to get the static or the  
    266 dynamic case nicer. 
    267 the patch is really simple, so give it a try. after all, i have no  
    268 particular opinion on this matter - i need to highlight trailing  
    269 whitespace only to annihilate any occurrences of it anyway. :-)=) 
    270         Oswald Buddenhagen <ossi> 
    271 Mon 30 Jan 2006 03:09:00 PM UTC, comment #1: 
    272  
    273 How about considering the trailing tabs a trailing whitespace too  
    274 and marking all the traling whitespace with just a dot ? 
    275  
    276 Now if a have a like like this: 
    277  
    278 int func()<space><space><space><space><tab><tab> 
    279  
    280 i get 
    281  
    282 int func() <><------><------> 
    283  
    284 This is pretty inconsistent and annoying (IMO). 
    285         Pavel Tsekov <ptsekov> 
    286 Project Administrator 
    287 Sat 21 May 2005 07:25:17 PM UTC, original submission: 
    288  
     9Original submission: 
     10{{{ 
    28911visible tabs help putting the tabs where you want them,  
    29012particularly when trying to stay consistent with the style of text  
     
    32345destroying the original whitespace anyway.  
    32446}}} 
     47 
     48Comment 1 by Pavel Tsekov <ptsekov> at Mon 30 Jan 2006 03:09:00 PM UTC: 
     49{{{ 
     50How about considering the trailing tabs a trailing whitespace too  
     51and marking all the traling whitespace with just a dot ? 
     52 
     53Now if a have a like like this: 
     54 
     55int func()<space><space><space><space><tab><tab> 
     56 
     57i get 
     58 
     59int func() <><------><------> 
     60 
     61This is pretty inconsistent and annoying (IMO). 
     62}}} 
     63 
     64Comment 2 by Oswald Buddenhagen <ossi> at Mon 30 Jan 2006 03:35:14 PM UTC: 
     65{{{ 
     66well, tabs should stay tabs. masking them away in this special case  
     67would just lead to surprises. 
     68not sure about your example. it's true that it looks a bit weird.  
     69otoh, such whitespace is plainly broken, so it should look broken.  
     70:) also, if you change it, suddenly chars in the middle of a line  
     71will vanish/appear if you (append past/remove up to) the trailing  
     72tabs. it depends on whether one wants to get the static or the  
     73dynamic case nicer. 
     74the patch is really simple, so give it a try. after all, i have no  
     75particular opinion on this matter - i need to highlight trailing  
     76whitespace only to annihilate any occurrences of it anyway. :-)=) 
     77}}} 
     78 
     79Comment 3 by Pavel Tsekov <ptsekov> at Mon 30 Jan 2006 03:53:54 PM UTC: 
     80{{{ 
     81I did try it and have been playing with it for a while. This patch 
     82adds (1) visible trailing spaces and (2) visible tabs. In fact I  
     83prefer to think of it as two separate patches. As you suggested on  
     84the list it should be enhanced so that the user can switch this  
     85functionality on and off via a fast key. I would add that the user  
     86should be allowed to enable (1) without enabling (2) and vice versa. 
     87}}} 
     88 
     89Comment 4 by Oswald Buddenhagen <ossi> at Mon 30 Jan 2006 04:19:36 PM UTC: 
     90{{{ 
     91ok, i changed my mind - i have a strong opinion now. :) 
     92i think it's right that trailing tabs should not prevent preceeding  
     93spaces from being marked as trailing: if trailing whitespace  
     94removal is implemented, all these chars will be equally killed away. 
     95}}} 
     96 
     97Comment 5 by Oswald Buddenhagen <ossi> at Mon 30 Jan 2006 04:33:20 PM UTC: 
     98{{{ 
     99ok, here's a patch which allows enabling visible trailing  
     100whitespace and visible tabs independently. i'm not eager to split  
     101it into two patches; they are too much related. 
     102i just threw in the options as variables right above the relevant  
     103function - i'd prefer you wrapping this into proper configurability  
     104(options in the edit config dialog and keyboard accels) yourself,  
     105as i'd have to research how to do it first. :} 
     106}}} 
     107 
     108Comment 6 by Pavel Tsekov <ptsekov> at Mon 30 Jan 2006 05:16:22 PM UTC: 
     109{{{ 
     110Single patch is OK. 
     111}}} 
     112 
     113Comment 7 by Oswald Buddenhagen <ossi> at Sun 05 Feb 2006 04:51:56 PM UTC: 
     114{{{ 
     115it just occurred to me, that i don't want two separate shortcuts  
     116for toggling these options. two separate persistent options in the  
     117config dialog are ok, but there should be only one "quick toggle"  
     118shortcut (ctrl-w) that disables both at once, and is not saved  
     119anywhere. 
     120i suppose the envisioned ctrl-s shortcut for toggling syntax  
     121highlighting should be non-persistent as well. 
     122}}} 
     123 
     124Comment 8 by Zbigniew Luszpinski <mr_zbiggy> at Thu 09 Aug 2007 08:28:12 PM UTC: 
     125{{{ 
     126This mcedit-visible-ws-v2.diff works great with mc-4.6.1 
     127What a pity it is not inside mc by default. The light blue color is  
     128great - it shows invisible characters but not disturbs  
     129reading/editing. 
     130 
     131There is one little thing I would like to see: 
     132make tabs, all spaces and carriage returns visible like in OpenOffice/M$ Word. 
     133 
     134This means that: 
     135-all spaces are visible as dots ···· (unicode 00B7) (not only  
     136trailing but all - this is comfortable when hunting for  
     137double/multi spaces between words). 
     138-tabs are visible as arrows → (unicode 2192) (somethhing like -> mc  
     139uses semigraphics so can draw arrows too) 
     140-carriage returns are visible as reversed P character ¶ (unicode  
     14100B6) 
     142(I know this is poor description but just run OO Writer or Word to  
     143see how these formating characters are marked). 
     144 
     145I really would like to see this patch in mc as default. It is very  
     146helpful and allows to keep .conf files clean. 
     147}}} 
     148 
     149Comment 9 by Oswald Buddenhagen <ossi> at Thu 09 Aug 2007 08:53:35 PM UTC: 
     150{{{ 
     151i considered making all whitespace visible, but somehow found it  
     152pointless and even counterproductive for my use cases. 
     153for linefeeds, i really see no use case ... 
     154regarding the use of special characters, this is not doable without  
     155utter hackery. mc is restricted to the abstract char set provided  
     156by ncurses/slang, which unfortunately does not provide these chars. 
     157}}} 
     158 
     159Comment 10 by Pavel Tsekov <ptsekov> at Mon 27 Aug 2007 12:08:04 PM UTC: 
     160{{{ 
     161The patch is in CVS now. I've commited mcedit-visible-ws-v2.diff  
     162with no changes whatsoever ... I'll be making changes to it as  
     163discussed in this bugreport in the next few weeks. 
     164}}} 
     165 
     166Comment 11 by Andrew Borodin <a_borodin> at Thu 30 Aug 2007 12:29:20 PM UTC: 
     167{{{ 
     168Cursor in TAB and trailing space position is disappeared. This is  
     169very uncomfortable. 
     170}}} 
     171 
     172Comment 12 by Pavel Tsekov <ptsekov> at Thu 30 Aug 2007 12:39:39 PM UTC: 
     173{{{ 
     174Yep. As I said - i'll be fixing the patch... I prefer to have it in  
     175CVS even if it has minor glitches. In the meantime if you find any  
     176other problems with it - please, feel free to report them. 
     177}}} 
     178 
     179Comment 13 by Oswald Buddenhagen <ossi> at Thu 30 Aug 2007 12:58:35 PM UTC: 
     180{{{ 
     181that's weird ... i see no such effect (little surprisingly). though  
     182with some terminals/color combinations it becomes light blue, too,  
     183and thus hardly visible, but i don't think we can do much about  
     184that. 
     185}}} 
     186 
     187Comment 14 by Andrew Borodin <a_borodin> at Fri 31 Aug 2007 06:07:28 AM UTC: 
     188{{{ 
     189Oswald, you are right. This effect is depending on terminal  
     190emulation program and color scheme. 
     191 
     192In linux console, cursor is visible every time. The color of cursor  
     193is changed to light blue in tab and trailing space positions, but  
     194cursor is visible. 
     195 
     196The same is in xterm under X. xterm doesn't have any non-default  
     197cursor settings. 
     198 
     199In gnome-terminal and multi-gnome-terminal, which I use, cursor  
     200changes its color and becomes invisible. ("Green on black" color  
     201scheme and "Linux console" palette are used in both those programs.) 
     202 
     203Is it possible to make the same cursor color in positions of  
     204visualized tab an training space as in positions of other symbols? 
     205}}} 
     206 
     207Comment 15 by Pavel Tsekov <ptsekov> at Fri 31 Aug 2007 09:28:17 AM UTC: 
     208{{{ 
     209This may be a bug in gnome-terminal as well... I am also using  
     210gnome-terminal and no matter the color scheme the cursor is  
     211invisible. I'll investigate further... 
     212}}} 
     213 
     214Comment 16 by Pavel Tsekov <ptsekov> at Fri 31 Aug 2007 04:19:43 PM UTC: 
     215{{{ 
     216IMO, this must be a bug in gnome-terminal. It doesn't behave  
     217properly if one uses both the bright and normal colors as the  
     218background and foreground of the same cell. I changed the 
     219the definition of "editwhitespace" to "brightred,red" and the  
     220cursor is not displayed in this case as well. I also changed the  
     221color for brightblue in my gnome-terminal profile to a different  
     222color but no matter the cursor wasnt displayed. I'll see if they  
     223have a bugreport in their bugzilla. 
     224}}} 
     225 
     226Comment 17 by Pavel Tsekov <ptsekov> at Mon 03 Sep 2007 01:15:42 PM UTC: 
     227{{{ 
     228Ok. I tracked the "bug" to vte_terminal_determine_colors() in the  
     229vte package. To request brighter colors one forces the terminal  
     230into "bold mode". It seems that in this mode vte allows only the  
     231foreground color to be bright. In vte's terms a bright color is the  
     232same color as the normal one but with a special flag set. So what  
     233happens is that when the time comes for the cursor to blink vte  
     234switches the current forground color with the current background  
     235color and vice versa... As I said above 
     236both colors are indentified in the same way but one has a special  
     237flag, however vte uses this flag to brighten the foreground color  
     238so at the end we end up as if nothing happened. It's hard to say  
     239whether this is the desired behaviour .. I'll attach a simple patch  
     240which changes vte to do what seems more logically correct... and  
     241I'll open a report in gnome's bugzilla. 
     242 
     243(file #13873) 
     244}}} 
     245 
     246Comment 18 by Andrew Borodin <a_borodin> at Tue 04 Sep 2007 05:29:40 AM UTC: 
     247{{{ 
     248Pavel, I applied your patch to vte-0.16.8. It works. 
     249}}} 
     250 
     251Comment 19 by Jurrie Overgoor <leadpumper> at Fri 29 Feb 2008 07:16:33 PM UTC: 
     252{{{ 
     253Oh, god... I just updated my Debian box, and I now run MC  
     2544.6.2-pre1 (as outputted by mcedit --version). It appears that this  
     255patch is included in this version of mcedit. I really dislike it.  
     256Besides suffering from the 'cursor disappearing' thingy, I just  
     257think its ugly. But that's my humble opinion :) 
     258How can I disable it? The patches attached to this report don't  
     259seem to make a new configurable parameter available in the  
     260configuration dialogs. 
     261}}} 
     262 
     263Comment 20 by Jan Engelhardt <hirogen2> at Sun 06 Jul 2008 01:17:43 PM UTC: 
     264{{{ 
     265Ok since nobody replied here are some patches of my own. 
     266They require that mc(edit) has COMPLETE support for UTF-8!, which  
     267is not the case in the mc source distribution. The openSUSE  
     268.src.rpm has the required utf8 bits. Will try to make them submit  
     269theirs. 
     270 
     271Patch #1 -- cedit-configurable-highlight.diff 
     272 
     273This is for comment #19; it allows to switch highlighting. Firstly,  
     274it adds a dialog (Options > Highlight options) where you can  
     275precisely select what to highlight 
     276 
     277[ ] Global syntax highlighting 
     278 
     279[ ] Tab highlighting (those <------> markers, which, btw, can get  
     280very ugly if you have lots of code) 
     281 
     282[ ] Whitespace highlighting (dots at the end-of-line, and, if tab  
     283highlighting is disabled, anywhere on the line) 
     284 
     285One can already toggle Syntax highlighting with Ctrl-S in mc 4.6.2,  
     286for the latter two, I added Ctrl-V as a hotkey which cycles through  
     287the possibilities. My personal preference is to have Tab highlight  
     288OFF and Whitespace highlight ON. 
     289 
     290(file #16003) 
     291}}} 
     292 
     293Comment 21 by Jan Engelhardt <hirogen2> at Sun 06 Jul 2008 01:19:54 PM UTC: 
     294{{{ 
     295Patch #2 -- cedit-eol-mark.diff 
     296 
     297This patch implements comment #8's suggestion to use ¶ as an EOL  
     298marker. It can be toggled using the Options>Highlight options  
     299dialog, or, of course, by editing ~/.mc/config directly. 
     300 
     301(file #16004) 
     302}}} 
     303 
     304Comment 22 by Jan Engelhardt <hirogen2> at Sun 06 Jul 2008 01:21:22 PM UTC: 
     305{{{ 
     306Patch #3 -- cedit-fix-whitespace.diff 
     307 
     308We definitely need to set MOD_WHITESPACE or the space between tab  
     309stops is drawn with some random color. 
     310 
     311(file #16005) 
     312}}} 
     313 
     314Comment 23 by Jan Engelhardt <hirogen2> at Sun 06 Jul 2008 01:24:09 PM UTC: 
     315{{{ 
     316Patch #4 -- cedit-symbol-prefs.diff 
     317 
     318This patch changes the space fill character to some Unicode dot (·)  
     319[this one is also available on the text console], and makes the  
     320<------> tab filler into the Unicode ◀──────▶ too. 
     321 
     322(file #16006) 
     323}}} 
     324 
     325Comment 24 by Jan Engelhardt <hirogen2> at Sun 06 Jul 2008 04:12:04 PM UTC: 
     326{{{ 
     327I noticed I cannot just use the Unicode characters (like p->ch =  
     3280xB7), as that does not take into account terminals that are not in  
     329UTF-8. But the fix is simple enough (p->ch = SLsmg_Is_Unicode ? 0xB7 : "."). 
     330 
     331BTW, I also implemented the MS Word-style "tabs", i.e. printing a  
     332right-arrow in the middle of a tab. I sort of prefer it over the  
     333"<---->" tabs. It is a patch that currently replaces the existing  
     334tab mechanism, but IMHO this should all be made configurable once  
     335the maintainers decide to wake up and give me some sort of ok... 
     336 
     337(file #16007) 
     338}}}